' THE WONDERFUL WORLD OF EAMON DELUXE ͻ
'                                                                
'                   By Frank Black 1997-1999                     
'                                                                
'         A computerized fantasy role-playing system             
'       based upon the Apple II version by Donald Brown,         
'          John Nelson, Tom Zuchowski, & Frank Black             
'                                                                
'   DUNGEON DESIGNER v2.6 MENU            Update: 10 JUL 1999    
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ

ON ERROR GOTO ErHndlr

TYPE DESC
   TEXT AS STRING * 255
END TYPE
DIM DS AS DESC

OPEN "SETTINGS.DAT" FOR INPUT AS #1: INPUT #1, dly, CC1, CC2, CC3: CLOSE
OPEN "DGNDIR.DAT" FOR INPUT AS #1: INPUT #1, d1, d2: CLOSE

IF d1 = 1 THEN
  CHDIR "..": CHDIR "DGN-1"
  OPEN "NAME.DAT" FOR INPUT AS #1
  INPUT #1, a, a, a, a, d1$
  CLOSE
  CHDIR "..": CHDIR "DD"
END IF
IF d2 = 1 THEN
  CHDIR "..": CHDIR "DGN-2"
  OPEN "NAME.DAT" FOR INPUT AS #1
  INPUT #1, a, a, a, a, d2$
  CLOSE
  CHDIR "..": CHDIR "DD"
END IF
IF d1 = 0 THEN d1$ = "(Empty)"
IF d2 = 0 THEN d2$ = "(Empty)"

'----------------------------------------------------
Menu:
CLS : COLOR 6: PRINT CHR$(218); STRING$(74, 196); CHR$(191)
PRINT CHR$(179); SPACE$(20); "EAMON DELUXE v2.6 DUNGEON DESIGNER";
PRINT SPACE$(20); CHR$(179): PRINT CHR$(192); STRING$(74, 196) + CHR$(217)
PRINT
PRINT "Design #1: "; d1$
PRINT "Design #2: "; d2$
PRINT
PRINT "   Select desired action:": PRINT
PRINT " 1. Start a new design"
PRINT " 2. Edit a design"
PRINT " 3. Test a design"
PRINT " 4. Edit hint files"
PRINT " 5. List a design"
PRINT " 6. Map room connections"
PRINT " 7. Remove a design"
PRINT " 8. Return to main menu": PRINT
PRINT "Enter 1-8: "; : GOSUB GetKey: k = INT(VAL(k$))
IF k < 1 OR k > 8 THEN GOTO Menu
ON k GOTO Init, Edit, Test, Hint, DList, Map, DsRemove, Quit
'------------------------------------------------
' Start a new dungeon
'
Init:
CLS
LINE INPUT "Name of adventure:"; advname$: PRINT
PRINT CHR$(34); advname$; CHR$(34): PRINT
PRINT "Is this correct? (Y/N): "; : GOSUB GetKey
IF k$ <> "Y" THEN GOTO Init

Init1:
CLS
PRINT "   Number of directions?": PRINT
PRINT " 1.  6 (N/S/E/W/U/D)"
PRINT " 2. 10 (N/S/E/W/U/D/NE/NW/SE/SW)"
PRINT "Enter 1-2: "; : GOSUB GetKey: a = INT(VAL(k$))
IF a < 1 OR a > 2 THEN GOTO Init1
x = a
IF a = 1 THEN nd = 6
IF a = 2 THEN nd = 10
F2 = 0
IF d1 = 0 THEN
  x = 1: d1 = 1: av$ = "DGN-1": GOTO InitDone
END IF
IF d2 = 0 THEN
  x = 2: d2 = 1: av$ = "DGN-2": GOTO InitDone
END IF

Init2:
CLS : PRINT "Your design slots are full.": PRINT
F2 = 1
PRINT " 1. Erase old design."
PRINT " 2. Abort"
PRINT "Enter 1-2: "; : GOSUB GetKey: a = INT(VAL(k$))
IF a < 1 OR a > 2 THEN GOTO Init2
IF a = 2 THEN GOTO Menu

Init3:
CLS : PRINT "Replace which design?": PRINT
PRINT "1: "; d1$: PRINT "2: "; d2$
PRINT "Enter 1-2: "; : GOSUB GetKey: a = INT(VAL(k$))
IF a < 1 OR a > 2 THEN GOTO Init3

CLS : PRINT "  !!!!! WARNING !!!!!": PRINT
PRINT "This will destroy any data in this design slot.": PRINT
PRINT "Replace ";
IF a = 1 THEN PRINT d1$;
IF a = 2 THEN PRINT d2$;
PRINT " with "; advname$; "?"
x = a
PRINT "Are you sure? (Y/N):"; : GOSUB GetKey
IF k$ <> "Y" THEN GOTO Menu
av$ = "DGN-" + LTRIM$(RTRIM$(STR$(x)))

InitDone:
CHDIR "..": CHDIR av$
'
' Init data files
'
IF F2 = 1 THEN KILL "*.*"
OPEN "NAME.DAT" FOR OUTPUT AS #1
WRITE #1, 0, 0, 0, 0, advname$, nd, 2, 1: CLOSE #1
OPEN "ROOMS.DAT" FOR RANDOM AS #1 LEN = 101
OPEN "ROOMS.DSC" FOR RANDOM AS #2 LEN = 255
OPEN "ARTIFACT.DAT" FOR RANDOM AS #3 LEN = 51
OPEN "ARTIFACT.DSC" FOR RANDOM AS #4 LEN = 255
CLOSE
OPEN "MONSTERS.DAT" FOR RANDOM AS #1 LEN = 61
OPEN "MONSTERS.DSC" FOR RANDOM AS #2 LEN = 255
OPEN "EFFECT.DSC" FOR RANDOM AS #3 LEN = 255
CLOSE
'
' Init savedir
'
OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1
PRINT #1, -1
FOR m = 1 TO 5: PRINT #1, "(none)": NEXT
CLOSE #1
'
' Init hint files
'
OPEN "HINTDIR.DAT" FOR OUTPUT AS #1
a = 1: b = 6: a$ = "General Help."
PRINT #1, a
PRINT #1, a$
PRINT #1, a, b
CLOSE

OPEN "HINTS.DSC" FOR RANDOM AS #1 LEN = 255
DS.TEXT = "1. Before you can manipulate items that are inside other items, you must REMOVE them."
PUT #1, 1, DS
DS.TEXT = "2. You can INVENTORY friendly monsters to see what they are carrying."
PUT #1, 2, DS
DS.TEXT = "3. If you GIVE a healing potion to a monster, they will take a drink and hand it back to you."
PUT #1, 3, DS
DS.TEXT = "4. The POWER spell has different effects in most adventures.  When all else fails try POWER."
PUT #1, 4, DS
DS.TEXT = "5. Sometimes things may be in a room but won't show up until you EXAMINE them.  Pay close attention to room descriptions."
PUT #1, 5, DS
DS.TEXT = "6. To give money to a monster, type GIVE and the amount.  (e.g. GIVE 200)"
PUT #1, 6, DS
CLOSE
CHDIR "..": CHDIR "DD"
OPEN "DGNDIR.DAT" FOR OUTPUT AS #1: PRINT #1, d1, d2: CLOSE

CLS : PRINT "Initializing data files...": PRINT

CHDIR "DGNFILES"
OPEN "intro.bas" FOR INPUT AS #1: CHDIR "..": CHDIR "..": CHDIR av$
OPEN "intro.bas" FOR OUTPUT AS #2: GOSUB MoveFile

CHDIR "DGNFILES"
OPEN "mainpgm.bas" FOR INPUT AS #1: CHDIR "..": CHDIR "..": CHDIR av$
OPEN "mainpgm.bas" FOR OUTPUT AS #2: GOSUB MoveFile

CHDIR "DGNFILES"
OPEN "install.bas" FOR INPUT AS #1: CHDIR "..": CHDIR "..": CHDIR av$
OPEN "install.bas" FOR OUTPUT AS #2: GOSUB MoveFile

CHDIR "DGNFILES"
OPEN "install.bat" FOR INPUT AS #1: CHDIR "..": CHDIR "..": CHDIR av$
OPEN "install.bat" FOR OUTPUT AS #2: GOSUB MoveFile

CLS
PRINT "A quick review of the BASIC programs...": PRINT
PRINT "              INTRO.BAS   --- Adventure Intro program."
PRINT "              MAINPGM.BAS --- The base dungeon program (your adventure)"
PRINT "INSTALL.BAT & INSTALL.BAS --- Copy ALL your dungeon files onto a disk in"
PRINT "the A:\ drive and run INSTALL.BAT to install your dungeon to the main list."
PRINT
PRINT "Your adventure is in directory: EAMONDX\DGN-"; LTRIM$(RTRIM$(STR$(x))); "."
PRINT : PRINT "Once you have added your adventure to the main list, make sure you remove it"
PRINT "from the design slot.  (Select 'Remove a design' from the menu.)"
PRINT : PRINT "Hit any key to continue."; : GOSUB GetKey: RUN
'
'  Somebody forgot to include a 'COPY' command w/ QBASIC!
' --------------------------------------------------------
MoveFile:
ON ERROR GOTO EndFile
MoveFile1:
LINE INPUT #1, a$: PRINT #2, a$: GOTO MoveFile1

EndFile:
IF ERR <> 62 THEN END
RESUME EndFile1
EndFile1:
ON ERROR GOTO ErHndlr: CLOSE : CHDIR "..": CHDIR "dd": RETURN

'---------------------------------------------
DsRemove:
CLS : PRINT "Remove which design?": PRINT
PRINT "1: "; d1$: PRINT "2: "; d2$
PRINT "Enter 1-2: "; : GOSUB GetKey: a = INT(VAL(k$))
IF a < 1 OR a > 2 THEN GOTO Menu
IF a = 1 AND d1 = 0 THEN
  PRINT "No dungeon to remove.": GOTO DsRemDone
END IF
IF a = 2 AND d2 = 0 THEN
  PRINT "No dungeon to remove.": GOTO DsRemDone
END IF

CLS : PRINT "  !!!!! WARNING !!!!!": PRINT
PRINT "This will destroy any data in this design slot.": PRINT
PRINT "Remove ";
IF a = 1 THEN PRINT d1$;
IF a = 2 THEN PRINT d2$;
PRINT "?"
x = a
PRINT "Are you sure? (Y/N):"; : GOSUB GetKey
IF k$ <> "Y" THEN GOTO Menu
a$ = "DGN-" + LTRIM$(RTRIM$(STR$(x)))
IF x = 1 THEN d1 = 0
IF x = 2 THEN d2 = 0

' Kill data files
CHDIR "..": CHDIR a$
KILL "*.*"
CHDIR "..": CHDIR "DD"
OPEN "DGNDIR.DAT" FOR OUTPUT AS #1
PRINT #1, d1, d2
CLOSE
'
PRINT : PRINT "Dungeon removed!"
DsRemDone:
PRINT : PRINT "Hit any key to continue."; : GOSUB GetKey: RUN
'--------------------------------------
Edit:
RUN "EDIT.BAS"
'
Test:
RUN "TEST.BAS"
'
Hint:
RUN "HINTEDIT.BAS"
'
DList:
RUN "LIST.BAS"
'
Map:
RUN "DGNMAP.BAS"
'
Quit:
OPEN "DGNDIR.DAT" FOR OUTPUT AS #1
PRINT #1, d1, d2
CLOSE
CHDIR ".."
RUN "STARTUP.BAS"
'----------------------------------------------------------------------------
'
' Get a single keypress, randomize RND seed while waiting
'
GetKey:
BS = POS(0): CC = 0
DO
   a = RND
   CC = CC + 1
   IF CC = CC1 THEN PRINT "/": LOCATE CSRLIN - 1, BS
   IF CC = CC2 THEN PRINT CHR$(179): LOCATE CSRLIN - 1, BS
   IF CC = CC3 THEN
      PRINT "\": LOCATE CSRLIN - 1, BS
      CC = 0
   END IF
   k$ = UCASE$(INKEY$)
LOOP UNTIL k$ <> ""
PRINT k$: RETURN

'Ŀ
'                    Error handling routine                     
'
ErHndlr:
CLS : BEEP: PRINT "Run-time error"; ERR; "   ";
IF ERR = 68 THEN PRINT "(Printer unavailable)";
IF ERR = 62 THEN PRINT "(Input past end of file)";
IF ERR = 53 THEN PRINT "(File not found)";
PRINT : PRINT : PRINT "Program terminated.": RESUME ErHndlr1
ErHndlr1:
ON ERROR GOTO 0: a$ = INKEY$: PRINT : PRINT "(Hit any key)"
DO
LOOP UNTIL INKEY$ <> ""
SYSTEM

